<?php

class MangeBbcodeController extends EpicBbCodeController {

    public function actionIndex() {
        $model = new BbCode('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['Bbcode']))
            $model->attributes = $_GET['Bbcode'];

        $this->render('index', array(
            'model' => $model,
        ));
    }

    public function actionCreate() {
        $model = new Bbcode();
        $description = NULL;

        $this->performAjaxValidation($model);


        if (isset($_POST['Bbcode']) && isset($_POST['Description'])) {
            $model->attributes = $_POST['Bbcode'];
            $description = new Description();
            $description->attributes = $_POST['Description'];
            $description->lang = 'en';
            if ($model->validate()) {
                $model->save();
                $description->bbcode_id = $model->id;
                if ($description->save())
                    $this->redirect('/epicBbCode/mangeBbCode/index');
            }else {
                if ($description->validate()) {
                    $model->addErrors($description->getErrors());
                }
            }
        }

        $this->render('create', array(
            'model' => $model,
            'description' => $description,
        ));
    }

    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id) {

        $model = $this->loadModel($id);
        $description = Description::model()->findByAttributes(array('bbcode_id' => $model->id, 'lang' => 'en'));

        $this->performAjaxValidation($model);

        if (isset($_POST['Bbcode']) && isset($_POST['Description'])) {
            $model->attributes = $_POST['Bbcode'];
            $description->attributes = $_POST['Description'];
            $description->lang = 'en';
            if ($model->validate() && $description->validate()) {
                $model->save();
                $description->bbcode_id = $model->id;
                if ($description->save())
                    $this->redirect('/epicBbCode/mangeBbCode/index');
            }else {
                if ($description->hasErrors()) {
                    $model->addErrors($description->getErrors());
                }
            }
        }

        $this->render('update', array(
            'model' => $model,
            'description' => $description,
        ));
    }

    public function actionDelete($id) {
        $this->loadModel($id)->delete();

        // if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
        if (!isset($_GET['ajax']))
            $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
    }

    public function actionView($id) {
        $model = $this->loadModel($id);
        $description = Description::model()->find('lang = "en" AND bbcode_id="' . $model->id . '"');
        if ($model != NULL) {
            $this->render('view', array(
                'model' => $model,
                'description' => $description,
            ));
        }
    }

    public function actionRenderText() {
        EpicEdit::makeToolBar();
        $text = "[b]test[/b][url=http://google.com][b][font=#ff0000]color red[/font][/b][/url][url=http://google.com][afb=http://assets.nerdwallet.com/blog/travel/files/2013/02/Travel-Warning.png]alttext[/afb][/url]";
        echo Bbcode::renderText($text);
    }

    public function actionCheckbox() {
        $model = $this->loadModel($_POST['id']);
        if ($model != NULL) {
            if ($model->active == 1) {
                $model->active = 0;
            } else {
                $model->active = 1;
            }
            $model->save();
        }
        Yii::app()->end();
    }

    protected function performAjaxValidation($model) {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'bbcode-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

    public function loadModel($id) {
        $model = BbCode::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

}
