<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of EpicEdit
 *
 * @author reinier
 */
class EpicEdit extends CWidget {

    public $id;
    public $attibute;
    public $model = array();
    public $htmlOptions = array();
    private $_assetsUrl;
    public $plugin = 'bbcode';
    public $emoticonsEnabled = 'false';
    public $style = '/themes/office.min.css';

    public function init() {
        $this->registerClientScript();
        return parent::init();
    }

    public function run() {
        echo CHtml::activeTextArea($this->model, $this->attibute, (isset($this->htmlOptions) ? $this->htmlOptions : array()));
    }

    public function getAssetsUrl() {
        return Yii::app()->assetManager->publish(dirname(__FILE__) . '\minified');
    }

    public function registerClientScript() {
        $cs = Yii::app()->clientScript;

        $cs->registerCssFile($this->AssetsUrl . '\themes\modern.min.css');
        $cs->registerScriptFile($this->AssetsUrl . '\jquery.sceditor.bbcode.min.js', CClientScript::POS_END);
        $cs->registerScript('textArea', "
    $('textarea').sceditor({
        plugins: '" . $this->plugin . "',
        emoticonsEnabled: " . $this->emoticonsEnabled . ",
        style: '" . $this->AssetsUrl . $this->style . "',
            toolbar: '" . $this->makeToolBar() . "'
    });");
        return $cs;
    }

    public static function makeToolBar() {
        $returnArray = array();
        $returnString = '';
        $toolBar = array(
            'bold', 'italic', 'underline', 'strike', '|',
            'subscript', 'superscript', '|',
            'left', 'center', 'right', 'justify', '|',
            'font', 'size', 'color', '|',
            'bulletlist', 'orderedlist', 'table', '|',
            'horizontalrule', 'code', 'quote', 'image', 'email', '|',
            'link', 'unlink', '|',
            'date','time','|',
            'youtube','print','|',
            'source', 'maximize', '|',
        );
        $criteria = new CDbCriteria();
        $criteria->with = 'bbcode';
        $criteria->distinct = true;
        $criteria->condition = 'bbcode.active=1';
        $bbcode = Description::model()->findAll($criteria);
        if ($bbcode != NULL) {
            array_push($returnArray, '|');
            foreach ($bbcode as $code) {
                array_push($returnArray, lcfirst($code->title));
            }
            $arrayMatch = array_intersect($toolBar, $returnArray);
            foreach ($arrayMatch as $match) {
                $returnString .= $match . ',';
            }
        }

        return $returnString . 'source,print,maximize';
    }

}
